--- xpdf-3.02/xpdf/XRef.cc
+++ xpdf-3.02/xpdf/XRef.cc
@@ -350,7 +350,8 @@
   GBool more;
   Object obj, obj2;
   Guint pos2;
-  int first, n, newSize, i;
+  int first, n, i;
+  SafeInt newSize;
 
   while (1) {
     parser->getObj(&obj);
@@ -372,7 +373,7 @@
       goto err1;
     }
     if (first + n > size) {
-      for (newSize = size ? 2 * size : 1024;
+      for (newSize = size ? SafeInt(2) * SafeInt(size) : 1024;
 	   first + n > newSize && newSize > 0;
 	   newSize <<= 1) ;
       if (newSize < 0) {
@@ -383,7 +384,7 @@
 	entries[i].offset = 0xffffffff;
 	entries[i].type = xrefEntryFree;
       }
-      size = newSize;
+      size = newSize.Int();
     }
     for (i = first; i < first + n; ++i) {
       if (!parser->getObj(&obj)->isInt()) {
@@ -471,7 +472,7 @@
   int w[3];
   GBool more;
   Object obj, obj2, idx;
-  int newSize, first, n, i;
+  int first, n, i, newSize;
 
   dict = xrefStr->getDict();
 
@@ -562,13 +563,14 @@
 
 GBool XRef::readXRefStreamSection(Stream *xrefStr, int *w, int first, int n) {
   Guint offset;
-  int type, gen, c, newSize, i, j;
+  int type, gen, c, i, j;
+  SafeInt newSize;
 
   if (first + n < 0) {
     return gFalse;
   }
   if (first + n > size) {
-    for (newSize = size ? 2 * size : 1024;
+    for (newSize = size ? SafeInt(2) * SafeInt(size) : 1024;
 	 first + n > newSize && newSize > 0;
 	 newSize <<= 1) ;
     if (newSize < 0) {
@@ -579,7 +581,7 @@
       entries[i].offset = 0xffffffff;
       entries[i].type = xrefEntryFree;
     }
-    size = newSize;
+    size = newSize.Int();
   }
   for (i = first; i < first + n; ++i) {
     if (w[0] == 0) {
@@ -637,8 +639,8 @@
   char buf[256];
   Guint pos;
   int num, gen;
-  int newSize;
-  int streamEndsSize;
+  SafeInt newSize;
+  SafeInt streamEndsSize;
   char *p;
   int i;
   GBool gotRoot;
@@ -649,7 +651,7 @@
 
   error(-1, "PDF file is damaged - attempting to reconstruct xref table...");
   gotRoot = gFalse;
-  streamEndsLen = streamEndsSize = 0;
+  streamEndsSize = streamEndsLen = 0;
 
   str->reset();
   while (1) {
@@ -708,7 +710,7 @@
 	      } while (*p && isspace(*p));
 	      if (!strncmp(p, "obj", 3)) {
 		if (num >= size) {
-		  newSize = (num + 1 + 255) & ~255;
+		  newSize = (SafeInt(num) + 1 + 255).Int() & ~255;
 		  if (newSize < 0) {
 		    error(-1, "Bad object number");
 		    return gFalse;
@@ -719,7 +721,7 @@
 		    entries[i].offset = 0xffffffff;
 		    entries[i].type = xrefEntryFree;
 		  }
-		  size = newSize;
+		  size = newSize.Int();
 		}
 		if (entries[num].type == xrefEntryFree ||
 		    gen >= entries[num].gen) {
--- xpdf-3.02/xpdf/pdffonts.cc
+++ xpdf-3.02/xpdf/pdffonts.cc
@@ -77,7 +77,7 @@
 
 static Ref *fonts;
 static int fontsLen;
-static int fontsSize;
+static SafeInt fontsSize;
 
 int main(int argc, char *argv[]) {
   PDFDoc *doc;
@@ -143,7 +143,7 @@
   printf("name                                 type              emb sub uni object ID\n");
   printf("------------------------------------ ----------------- --- --- --- ---------\n");
   fonts = NULL;
-  fontsLen = fontsSize = 0;
+  fontsSize = fontsLen = 0;
   for (pg = firstPage; pg <= lastPage; ++pg) {
     page = doc->getCatalog()->getPage(pg);
     if ((resDict = page->getResourceDict())) {
